* This routine dynamically sizes a window and post the string m_msg in
* the window and asks the user for a resonse by choosing Yes or No
* pushbutton.  The value of this response is placed in memvar m_ans which
* must be established prior to calling this procedure.  The second parameter 
* is for the default prompt.  The program defaults to "No" if no value sent
* for the second parameter
* 
PARA m_msg, m_defa
PUSH KEY CLEAR
PRIVATE m_choice

IF PARAMETERS() = 1 .OR. m_defa $ "Yy"
	m_defa = 1
ELSE
	m_defa = 2
ENDIF
m_choice1 = 0
m_choice2 = 0
	
IF TYPE('m_ans') = 'U'	
	PUBLIC m_ans
ENDIF
	
SET TALK OFF

sy_esc = SET('ESCAPE') = 'ON'
SET ESCAPE OFF

m_msg = ALLTRIM(m_msg)
m_msg = ' '+m_msg+' '

IF LEN(m_msg) <= 15
	msg_len = 15
ELSE
	msg_len = LEN(m_msg)
ENDIF
DO CASE
	CASE msg_len = 15
		say_col = 0
		m_space = 2
	CASE MOD((msg_len-15),3) = 0
		say_col = INT((msg_len-14)/3)
		m_space = (INT((msg_len-15)/3))
	CASE MOD((msg_len-15),3) <> 0 
		say_col = INT((msg_len-15) /3)
		m_space = say_col + MOD((msg_len-15),3)+1
ENDCASE

wsize = msg_len + 1


IF NOT WEXIST("yn_diag")
	DEFINE WINDOW yn_diag ;
		FROM INT((SROW()-5)/2),INT((SCOL()-WSIZE)/2) ;
		TO INT((SROW()-5)/2)+4,INT((SCOL()-WSIZE)/2)+WSIZE ;
		FLOAT ;
		NOCLOSE ;
		SHADOW ;
		DOUBLE ;
		COLOR SCHEME 5
ENDIF

ACTIVATE WINDOW yn_diag NOSHOW

@ 2,SAY_COL GET m_choice1 ;
	PICTURE "@*HT  \<Yes" ;
	SIZE 1,7,1 ;
	COLOR SCHEME 5

@ 2,SAY_COL+m_space+7 GET m_choice2 ;
	PICTURE "@*HT \<No" ;
	SIZE 1,6,1 ;
	COLOR SCHEME 5



SET BELL TO 1500,4 		&& play a little tune
?? CHR(7)
SET BELL TO 2000,4
?? CHR(7)
SET BELL TO 1700,4
?? CHR(7)
SET BELL TO          


READ SHOW ynshow()



RELEASE WINDOW yn_diag

IF m_choice1 = 1
	m_ans = 'Yes'
ELSE
	m_ans = 'No'
ENDIF

IF sy_esc
   SET ESCAPE ON
ENDIF

POP KEY

FUNCTION ynshow
	ACTIVATE WINDOW yn_diag 
	@ 0,0 SAY PADC(ALLTRIM(m_msg),msg_len)
	_CUROBJ = m_defa
RETURN .T.
